@div:coverpage
# C#の基本中の基本を<br>覚えよう
@divend

<!-- @div:secheader -->
## 最初のプログラムを<br>書いてみよう
<!-- @divend -->

最初の一歩として、文字を表示するだけの簡単なプログラム（スクリプト）を書いてみましょう。ここではプログラムの内容そのものではなく、プロジェクトのつくり方からエディタの使い方までの手順を覚えてください。



### プロジェクトの中にスクリプトを追加しよう

#### プロジェクトの作成
Ｕｎｉｔｙでプログラムを書くには、その前にいくつか作成しなければいけないものがあります。最初につくるのは**プロジェクト**です。プロジェクトはゲームに必要なプログラムや画像、音楽などのデータをまとめる容れ物です

Ｕｎｉｔｙエディタの起動時に表示される**ホーム画面**でプロジェクトを作成します。名前は「ＦｉｒｓｔＬｅｓｓｏｎ」とし、保存場所はどこでもいいのでとりあえず［ドキュメント］フォルダ（Ｍａｃでは［書類］フォルダ）にしておきましょう。

####  Ｕｎｉｔｙエディタの画面各部の名称

プロジェクトを作成すると、そのプロジェクトが開かれた状態でＵｎｉｔｙエディタが起動します。ここで画面各部の名称と役割を簡単に説明しておきましょう。Ｗｉｎｄｏｗｓ版もＭａｃ版も画面はほとんど一緒ですが、Ｍａｃではメニューバーはデスクトップの上部に表示されます。また、画面構成は使いやすいようにカスタマイズすることもできます（Ｐ．■■のコラムを参照）。


#### アクセス修飾子でメンバーを保護する
メンバー変数の前にｐｕｂｌｉｃを付けないとなぜエラーになったのでしょうか？　また、Ｌｅｓｓｏｎ１クラスにはｐｕｂｌｉｃを付けているのに、Ｐｅｒｓｏｎクラスにはなぜ付けないのでしょうか。実は、クラスやそのメンバーは、**外部から利用していいかどうか**が決まっており、それを変更するｐｕｂｌｉｃなどのキーワードを**アクセス修飾子**といいます。

先にそういうしくみがある理由を、たとえ話で説明しましょう。ハードディスクでも何でもいいのですが、ＵＳＢ接続の周辺機器を想像してみてください。この機器をＵＳＢケーブルでパソコンに接続するのは正しい使い方ですね。でも、ドライバーでカバーを空けて、中にある部品をいじるのは間違った（少なくともマニアックな）使い方です。
<!-- @divend -->
## クラスについてもう少しだけ<br>知っておこう
<!-- @divend -->
これまで無視してきた「クラス」ですが、実は重要な役割を持っています。
ここではクラスの目的や使い方を、Ｕｎｉｔｙを使う上で必要な範囲に絞って説明します。


### クラスは何のためにある？
#### クラスが産まれた経緯
ここまでクラスについてはあまり触れずに進めてきました。クラスを理解するためにプログラミング言語のざっくりとした歴史から入っていきましょう。

昔のプログラム言語にはクラスはなく、変数とメソッド（当時は「関数」や「サブルーチン」と呼ばれることが多かったようです）だけがありました。それはそれでシンプルでよかったのですが、プログラムの規模が大きくなり、数百行、数千行、数万行……と増えてくると、どの変数が何を記録し、どのメソッドがどんな仕事をしているのか把握するのが難しくなってきます。そこで**変数やメソッドをグループ化して扱う**ようにする手法が産まれ、それをルール化したものがクラスなのです。Ｃ＃ではクラスは絶対的なルールになっているので、クラスをつくらずに変数やメソッドだけをつくることはできません。

#### クラスからインスタンスをつくる
ボタンが1つしかないアプリは普通ありません。たいてい［ＯＫ］や［Ｃａｎｃｅｌ］など複数のボタンが配置されています。ということは、Ｂｕｔｔｏｎクラスをつくるとしても、複数配置できるようにしなければいけません。
そのためのしくみもＣ＃の中にちゃんと用意されています。

Ｃ＃ではクラスはあくまで設計図と見なし、クラスをもとに実際に使う実体をつくります。クラスからつくった実体のことを**インスタンス**と呼びます。

あとで実例を使って説明しますが、クラスからインスタンスをつくるには、**ｎｅｗ演算子**を使って、次のような感じに書きます。
ちょっとイメージしにくいかもしれませんが、クラスからインスタンスをつくると、プログラムが動くメモリ空間の中に、インスタンスを記録する領域が確保されます。それぞれメモリ上の別の場所に確保されるので、異なる値を記録できるわけです。


また、クラスの中のメソッドや変数を利用したいときは、Ｄｅｂｕｇ．Ｌｏｇのように.（ドット）演算子を利用します。
Ｓｔａｒｔメソッドを書くと初期化時に実行されたのも、ＭｏｎｏＢｅｈａｖｉｏｕｒクラスの機能を引き継いでいるおかげです。

@div:figure
![](img2/c2s1-14.png?svgimg=21,91,55,,0)
![](img2/c2s1-23.png?svgimg=32,91,55,,0)
@div:figcaptionヒエラルキーとインスペクターに表示されたゲームオブジェクト@divend
@divend
